"use strict";

const types = require("@babel/types");

module.exports = {
	name: "literals",
	visitors: {
		NixIntegerLiteral: (node) => types.numericLiteral(parseInt(node.value)),
		NixFloatLiteral: (node) => types.numericLiteral(parseFloat(node.value)),
		NixStringLiteral: (node) => {
			if (node.parts.length === 1 && node.parts[0].type === "NixInterpolationLiteral") {
				// Fast case; just a simple, non-interpolated string literal
				return types.stringLiteral(node.parts[0].value);
			} else {
				throw new Error(`Unimplemented: string interpolation is not supported yet`);
			}
		}
	}
};
